<?php

class ThemeIntegrations
{

  public static $theme;

  public function __construct() {
    self::$theme = $this->getThemeName();
  }


  public function getThemeName() {
    $current_theme = wp_get_theme();
    return strtolower($current_theme->get('Name'));
  }


  public function getIntegration($html) {
    if (file_exists(WPS_IC_DIR . 'integrations/themes/' . self::$theme . '.php')) {

      require_once WPS_IC_DIR . 'integrations/themes/' . self::$theme . '.php';
      $className = 'wpc_'.self::$theme;

      if (class_exists($className)) {
        $class = new $className();
        return $class->runIntegration($html);
      }

    } else if (defined('ELEMENTOR_VERSION')) {
	    $elementor = new wps_ic_elementor();
			return $elementor->runIntegration($html);
    } else {
      return $html;
    }
  }


}